/*
 * global.h
 *
 * Created: 28-11-17 13:53:21
 *  Author: Adrien
 */ 


#ifndef GLOBAL_H_
#define GLOBAL_H_

#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>


#define __BP_PLUS__ PINB0
#define __BP_MOIN__ PINB1
#define __BP_CONF__ PINB3
#define __BP_START__ PINB2
#define __TMP_BP_MAX__ 1000 //Acc?l?ration Min
#define __TMP_BP_MIN__ 50  //Acc?leration MAx
#define __TMP_BP_NLOOP_DEC__ 2 //Acc?l?ration apr?s x incr?mentation/d?cr?mentation
#define __TMP_BP_SETUP__ 500 //tmp pour rentrer dans le setup
typedef enum { NONE = 0, LCONF = 1, RCONF = 2} setup_t;
typedef enum {NORMALMODE = 0, CHRONO = 1, MINUTERIE = 2, REVEIL = 3} mode_t;
extern uint8_t appuisBPflag;



#endif /* GLOBAL_H_ */